mmv1/products/compute/BackendService.yaml [1088:1320]:
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    properties:
      - name: 'baseEjectionTime'
        type: NestedObject
        description: |
          The base time that a host is ejected for. The real time is equal to the base
          time multiplied by the number of times the host has been ejected. Defaults to
          30000ms or 30s.
        at_least_one_of:
          - 'outlier_detection.0.base_ejection_time'
          - 'outlier_detection.0.consecutive_errors'
          - 'outlier_detection.0.consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_consecutive_errors'
          - 'outlier_detection.0.enforcing_consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_success_rate'
          - 'outlier_detection.0.interval'
          - 'outlier_detection.0.max_ejection_percent'
          - 'outlier_detection.0.success_rate_minimum_hosts'
          - 'outlier_detection.0.success_rate_request_volume'
          - 'outlier_detection.0.success_rate_stdev_factor'
        properties:
          - name: 'seconds'
            type: Integer
            description: |
              Span of time at a resolution of a second. Must be from 0 to 315,576,000,000
              inclusive.
            required: true
          - name: 'nanos'
            type: Integer
            description: |
              Span of time that's a fraction of a second at nanosecond resolution. Durations
              less than one second are represented with a 0 `seconds` field and a positive
              `nanos` field. Must be from 0 to 999,999,999 inclusive.
      - name: 'consecutiveErrors'
        type: Integer
        description: |
          Number of errors before a host is ejected from the connection pool. When the
          backend host is accessed over HTTP, a 5xx return code qualifies as an error.
          Defaults to 5.
        at_least_one_of:
          - 'outlier_detection.0.base_ejection_time'
          - 'outlier_detection.0.consecutive_errors'
          - 'outlier_detection.0.consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_consecutive_errors'
          - 'outlier_detection.0.enforcing_consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_success_rate'
          - 'outlier_detection.0.interval'
          - 'outlier_detection.0.max_ejection_percent'
          - 'outlier_detection.0.success_rate_minimum_hosts'
          - 'outlier_detection.0.success_rate_request_volume'
          - 'outlier_detection.0.success_rate_stdev_factor'
      - name: 'consecutiveGatewayFailure'
        type: Integer
        description: |
          The number of consecutive gateway failures (502, 503, 504 status or connection
          errors that are mapped to one of those status codes) before a consecutive
          gateway failure ejection occurs. Defaults to 5.
        at_least_one_of:
          - 'outlier_detection.0.base_ejection_time'
          - 'outlier_detection.0.consecutive_errors'
          - 'outlier_detection.0.consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_consecutive_errors'
          - 'outlier_detection.0.enforcing_consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_success_rate'
          - 'outlier_detection.0.interval'
          - 'outlier_detection.0.max_ejection_percent'
          - 'outlier_detection.0.success_rate_minimum_hosts'
          - 'outlier_detection.0.success_rate_request_volume'
          - 'outlier_detection.0.success_rate_stdev_factor'
      - name: 'enforcingConsecutiveErrors'
        type: Integer
        description: |
          The percentage chance that a host will be actually ejected when an outlier
          status is detected through consecutive 5xx. This setting can be used to disable
          ejection or to ramp it up slowly. Defaults to 100.
        at_least_one_of:
          - 'outlier_detection.0.base_ejection_time'
          - 'outlier_detection.0.consecutive_errors'
          - 'outlier_detection.0.consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_consecutive_errors'
          - 'outlier_detection.0.enforcing_consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_success_rate'
          - 'outlier_detection.0.interval'
          - 'outlier_detection.0.max_ejection_percent'
          - 'outlier_detection.0.success_rate_minimum_hosts'
          - 'outlier_detection.0.success_rate_request_volume'
          - 'outlier_detection.0.success_rate_stdev_factor'
      - name: 'enforcingConsecutiveGatewayFailure'
        type: Integer
        description: |
          The percentage chance that a host will be actually ejected when an outlier
          status is detected through consecutive gateway failures. This setting can be
          used to disable ejection or to ramp it up slowly. Defaults to 0.
        at_least_one_of:
          - 'outlier_detection.0.base_ejection_time'
          - 'outlier_detection.0.consecutive_errors'
          - 'outlier_detection.0.consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_consecutive_errors'
          - 'outlier_detection.0.enforcing_consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_success_rate'
          - 'outlier_detection.0.interval'
          - 'outlier_detection.0.max_ejection_percent'
          - 'outlier_detection.0.success_rate_minimum_hosts'
          - 'outlier_detection.0.success_rate_request_volume'
          - 'outlier_detection.0.success_rate_stdev_factor'
      - name: 'enforcingSuccessRate'
        type: Integer
        description: |
          The percentage chance that a host will be actually ejected when an outlier
          status is detected through success rate statistics. This setting can be used to
          disable ejection or to ramp it up slowly. Defaults to 100.
        at_least_one_of:
          - 'outlier_detection.0.base_ejection_time'
          - 'outlier_detection.0.consecutive_errors'
          - 'outlier_detection.0.consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_consecutive_errors'
          - 'outlier_detection.0.enforcing_consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_success_rate'
          - 'outlier_detection.0.interval'
          - 'outlier_detection.0.max_ejection_percent'
          - 'outlier_detection.0.success_rate_minimum_hosts'
          - 'outlier_detection.0.success_rate_request_volume'
          - 'outlier_detection.0.success_rate_stdev_factor'
      - name: 'interval'
        type: NestedObject
        description: |
          Time interval between ejection sweep analysis. This can result in both new
          ejections as well as hosts being returned to service. Defaults to 10 seconds.
        at_least_one_of:
          - 'outlier_detection.0.base_ejection_time'
          - 'outlier_detection.0.consecutive_errors'
          - 'outlier_detection.0.consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_consecutive_errors'
          - 'outlier_detection.0.enforcing_consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_success_rate'
          - 'outlier_detection.0.interval'
          - 'outlier_detection.0.max_ejection_percent'
          - 'outlier_detection.0.success_rate_minimum_hosts'
          - 'outlier_detection.0.success_rate_request_volume'
          - 'outlier_detection.0.success_rate_stdev_factor'
        properties:
          - name: 'seconds'
            type: Integer
            description: |
              Span of time at a resolution of a second. Must be from 0 to 315,576,000,000
              inclusive.
            required: true
          - name: 'nanos'
            type: Integer
            description: |
              Span of time that's a fraction of a second at nanosecond resolution. Durations
              less than one second are represented with a 0 `seconds` field and a positive
              `nanos` field. Must be from 0 to 999,999,999 inclusive.
      - name: 'maxEjectionPercent'
        type: Integer
        description: |
          Maximum percentage of hosts in the load balancing pool for the backend service
          that can be ejected. Defaults to 10%.
        at_least_one_of:
          - 'outlier_detection.0.base_ejection_time'
          - 'outlier_detection.0.consecutive_errors'
          - 'outlier_detection.0.consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_consecutive_errors'
          - 'outlier_detection.0.enforcing_consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_success_rate'
          - 'outlier_detection.0.interval'
          - 'outlier_detection.0.max_ejection_percent'
          - 'outlier_detection.0.success_rate_minimum_hosts'
          - 'outlier_detection.0.success_rate_request_volume'
          - 'outlier_detection.0.success_rate_stdev_factor'
      - name: 'successRateMinimumHosts'
        type: Integer
        description: |
          The number of hosts in a cluster that must have enough request volume to detect
          success rate outliers. If the number of hosts is less than this setting, outlier
          detection via success rate statistics is not performed for any host in the
          cluster. Defaults to 5.
        at_least_one_of:
          - 'outlier_detection.0.base_ejection_time'
          - 'outlier_detection.0.consecutive_errors'
          - 'outlier_detection.0.consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_consecutive_errors'
          - 'outlier_detection.0.enforcing_consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_success_rate'
          - 'outlier_detection.0.interval'
          - 'outlier_detection.0.max_ejection_percent'
          - 'outlier_detection.0.success_rate_minimum_hosts'
          - 'outlier_detection.0.success_rate_request_volume'
          - 'outlier_detection.0.success_rate_stdev_factor'
      - name: 'successRateRequestVolume'
        type: Integer
        description: |
          The minimum number of total requests that must be collected in one interval (as
          defined by the interval duration above) to include this host in success rate
          based outlier detection. If the volume is lower than this setting, outlier
          detection via success rate statistics is not performed for that host. Defaults
          to 100.
        at_least_one_of:
          - 'outlier_detection.0.base_ejection_time'
          - 'outlier_detection.0.consecutive_errors'
          - 'outlier_detection.0.consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_consecutive_errors'
          - 'outlier_detection.0.enforcing_consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_success_rate'
          - 'outlier_detection.0.interval'
          - 'outlier_detection.0.max_ejection_percent'
          - 'outlier_detection.0.success_rate_minimum_hosts'
          - 'outlier_detection.0.success_rate_request_volume'
          - 'outlier_detection.0.success_rate_stdev_factor'
      - name: 'successRateStdevFactor'
        type: Integer
        description: |
          This factor is used to determine the ejection threshold for success rate outlier
          ejection. The ejection threshold is the difference between the mean success
          rate, and the product of this factor and the standard deviation of the mean
          success rate: mean - (stdev * success_rate_stdev_factor). This factor is divided
          by a thousand to get a double. That is, if the desired factor is 1.9, the
          runtime value should be 1900. Defaults to 1900.
        at_least_one_of:
          - 'outlier_detection.0.base_ejection_time'
          - 'outlier_detection.0.consecutive_errors'
          - 'outlier_detection.0.consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_consecutive_errors'
          - 'outlier_detection.0.enforcing_consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_success_rate'
          - 'outlier_detection.0.interval'
          - 'outlier_detection.0.max_ejection_percent'
          - 'outlier_detection.0.success_rate_minimum_hosts'
          - 'outlier_detection.0.success_rate_request_volume'
          - 'outlier_detection.0.success_rate_stdev_factor'
  # 'port' is deprecated
  - name: 'portName'
    type: String
    description: |
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -



mmv1/products/compute/RegionBackendService.yaml [979:1210]:
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    properties:
      - name: 'baseEjectionTime'
        type: NestedObject
        description: |
          The base time that a host is ejected for. The real time is equal to the base
          time multiplied by the number of times the host has been ejected. Defaults to
          30000ms or 30s.
        at_least_one_of:
          - 'outlier_detection.0.base_ejection_time'
          - 'outlier_detection.0.consecutive_errors'
          - 'outlier_detection.0.consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_consecutive_errors'
          - 'outlier_detection.0.enforcing_consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_success_rate'
          - 'outlier_detection.0.interval'
          - 'outlier_detection.0.max_ejection_percent'
          - 'outlier_detection.0.success_rate_minimum_hosts'
          - 'outlier_detection.0.success_rate_request_volume'
          - 'outlier_detection.0.success_rate_stdev_factor'
        properties:
          - name: 'seconds'
            type: Integer
            description: |
              Span of time at a resolution of a second. Must be from 0 to 315,576,000,000
              inclusive.
            required: true
          - name: 'nanos'
            type: Integer
            description: |
              Span of time that's a fraction of a second at nanosecond resolution. Durations
              less than one second are represented with a 0 `seconds` field and a positive
              `nanos` field. Must be from 0 to 999,999,999 inclusive.
      - name: 'consecutiveErrors'
        type: Integer
        description: |
          Number of errors before a host is ejected from the connection pool. When the
          backend host is accessed over HTTP, a 5xx return code qualifies as an error.
          Defaults to 5.
        at_least_one_of:
          - 'outlier_detection.0.base_ejection_time'
          - 'outlier_detection.0.consecutive_errors'
          - 'outlier_detection.0.consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_consecutive_errors'
          - 'outlier_detection.0.enforcing_consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_success_rate'
          - 'outlier_detection.0.interval'
          - 'outlier_detection.0.max_ejection_percent'
          - 'outlier_detection.0.success_rate_minimum_hosts'
          - 'outlier_detection.0.success_rate_request_volume'
          - 'outlier_detection.0.success_rate_stdev_factor'
      - name: 'consecutiveGatewayFailure'
        type: Integer
        description: |
          The number of consecutive gateway failures (502, 503, 504 status or connection
          errors that are mapped to one of those status codes) before a consecutive
          gateway failure ejection occurs. Defaults to 5.
        at_least_one_of:
          - 'outlier_detection.0.base_ejection_time'
          - 'outlier_detection.0.consecutive_errors'
          - 'outlier_detection.0.consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_consecutive_errors'
          - 'outlier_detection.0.enforcing_consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_success_rate'
          - 'outlier_detection.0.interval'
          - 'outlier_detection.0.max_ejection_percent'
          - 'outlier_detection.0.success_rate_minimum_hosts'
          - 'outlier_detection.0.success_rate_request_volume'
          - 'outlier_detection.0.success_rate_stdev_factor'
      - name: 'enforcingConsecutiveErrors'
        type: Integer
        description: |
          The percentage chance that a host will be actually ejected when an outlier
          status is detected through consecutive 5xx. This setting can be used to disable
          ejection or to ramp it up slowly. Defaults to 100.
        at_least_one_of:
          - 'outlier_detection.0.base_ejection_time'
          - 'outlier_detection.0.consecutive_errors'
          - 'outlier_detection.0.consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_consecutive_errors'
          - 'outlier_detection.0.enforcing_consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_success_rate'
          - 'outlier_detection.0.interval'
          - 'outlier_detection.0.max_ejection_percent'
          - 'outlier_detection.0.success_rate_minimum_hosts'
          - 'outlier_detection.0.success_rate_request_volume'
          - 'outlier_detection.0.success_rate_stdev_factor'
      - name: 'enforcingConsecutiveGatewayFailure'
        type: Integer
        description: |
          The percentage chance that a host will be actually ejected when an outlier
          status is detected through consecutive gateway failures. This setting can be
          used to disable ejection or to ramp it up slowly. Defaults to 0.
        at_least_one_of:
          - 'outlier_detection.0.base_ejection_time'
          - 'outlier_detection.0.consecutive_errors'
          - 'outlier_detection.0.consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_consecutive_errors'
          - 'outlier_detection.0.enforcing_consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_success_rate'
          - 'outlier_detection.0.interval'
          - 'outlier_detection.0.max_ejection_percent'
          - 'outlier_detection.0.success_rate_minimum_hosts'
          - 'outlier_detection.0.success_rate_request_volume'
          - 'outlier_detection.0.success_rate_stdev_factor'
      - name: 'enforcingSuccessRate'
        type: Integer
        description: |
          The percentage chance that a host will be actually ejected when an outlier
          status is detected through success rate statistics. This setting can be used to
          disable ejection or to ramp it up slowly. Defaults to 100.
        at_least_one_of:
          - 'outlier_detection.0.base_ejection_time'
          - 'outlier_detection.0.consecutive_errors'
          - 'outlier_detection.0.consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_consecutive_errors'
          - 'outlier_detection.0.enforcing_consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_success_rate'
          - 'outlier_detection.0.interval'
          - 'outlier_detection.0.max_ejection_percent'
          - 'outlier_detection.0.success_rate_minimum_hosts'
          - 'outlier_detection.0.success_rate_request_volume'
          - 'outlier_detection.0.success_rate_stdev_factor'
      - name: 'interval'
        type: NestedObject
        description: |
          Time interval between ejection sweep analysis. This can result in both new
          ejections as well as hosts being returned to service. Defaults to 10 seconds.
        at_least_one_of:
          - 'outlier_detection.0.base_ejection_time'
          - 'outlier_detection.0.consecutive_errors'
          - 'outlier_detection.0.consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_consecutive_errors'
          - 'outlier_detection.0.enforcing_consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_success_rate'
          - 'outlier_detection.0.interval'
          - 'outlier_detection.0.max_ejection_percent'
          - 'outlier_detection.0.success_rate_minimum_hosts'
          - 'outlier_detection.0.success_rate_request_volume'
          - 'outlier_detection.0.success_rate_stdev_factor'
        properties:
          - name: 'seconds'
            type: Integer
            description: |
              Span of time at a resolution of a second. Must be from 0 to 315,576,000,000
              inclusive.
            required: true
          - name: 'nanos'
            type: Integer
            description: |
              Span of time that's a fraction of a second at nanosecond resolution. Durations
              less than one second are represented with a 0 `seconds` field and a positive
              `nanos` field. Must be from 0 to 999,999,999 inclusive.
      - name: 'maxEjectionPercent'
        type: Integer
        description: |
          Maximum percentage of hosts in the load balancing pool for the backend service
          that can be ejected. Defaults to 10%.
        at_least_one_of:
          - 'outlier_detection.0.base_ejection_time'
          - 'outlier_detection.0.consecutive_errors'
          - 'outlier_detection.0.consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_consecutive_errors'
          - 'outlier_detection.0.enforcing_consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_success_rate'
          - 'outlier_detection.0.interval'
          - 'outlier_detection.0.max_ejection_percent'
          - 'outlier_detection.0.success_rate_minimum_hosts'
          - 'outlier_detection.0.success_rate_request_volume'
          - 'outlier_detection.0.success_rate_stdev_factor'
      - name: 'successRateMinimumHosts'
        type: Integer
        description: |
          The number of hosts in a cluster that must have enough request volume to detect
          success rate outliers. If the number of hosts is less than this setting, outlier
          detection via success rate statistics is not performed for any host in the
          cluster. Defaults to 5.
        at_least_one_of:
          - 'outlier_detection.0.base_ejection_time'
          - 'outlier_detection.0.consecutive_errors'
          - 'outlier_detection.0.consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_consecutive_errors'
          - 'outlier_detection.0.enforcing_consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_success_rate'
          - 'outlier_detection.0.interval'
          - 'outlier_detection.0.max_ejection_percent'
          - 'outlier_detection.0.success_rate_minimum_hosts'
          - 'outlier_detection.0.success_rate_request_volume'
          - 'outlier_detection.0.success_rate_stdev_factor'
      - name: 'successRateRequestVolume'
        type: Integer
        description: |
          The minimum number of total requests that must be collected in one interval (as
          defined by the interval duration above) to include this host in success rate
          based outlier detection. If the volume is lower than this setting, outlier
          detection via success rate statistics is not performed for that host. Defaults
          to 100.
        at_least_one_of:
          - 'outlier_detection.0.base_ejection_time'
          - 'outlier_detection.0.consecutive_errors'
          - 'outlier_detection.0.consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_consecutive_errors'
          - 'outlier_detection.0.enforcing_consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_success_rate'
          - 'outlier_detection.0.interval'
          - 'outlier_detection.0.max_ejection_percent'
          - 'outlier_detection.0.success_rate_minimum_hosts'
          - 'outlier_detection.0.success_rate_request_volume'
          - 'outlier_detection.0.success_rate_stdev_factor'
      - name: 'successRateStdevFactor'
        type: Integer
        description: |
          This factor is used to determine the ejection threshold for success rate outlier
          ejection. The ejection threshold is the difference between the mean success
          rate, and the product of this factor and the standard deviation of the mean
          success rate: mean - (stdev * success_rate_stdev_factor). This factor is divided
          by a thousand to get a double. That is, if the desired factor is 1.9, the
          runtime value should be 1900. Defaults to 1900.
        at_least_one_of:
          - 'outlier_detection.0.base_ejection_time'
          - 'outlier_detection.0.consecutive_errors'
          - 'outlier_detection.0.consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_consecutive_errors'
          - 'outlier_detection.0.enforcing_consecutive_gateway_failure'
          - 'outlier_detection.0.enforcing_success_rate'
          - 'outlier_detection.0.interval'
          - 'outlier_detection.0.max_ejection_percent'
          - 'outlier_detection.0.success_rate_minimum_hosts'
          - 'outlier_detection.0.success_rate_request_volume'
          - 'outlier_detection.0.success_rate_stdev_factor'
  - name: 'portName'
    type: String
    description: |
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -



